#! /bin/sh -e

# This is a proof-of-concept script. I'm at best a bumbling amateur
# when it comes to shell scripting. # Use this script from an empty
# directory. Required packages (Debian):
#
# - cdrdao
# - bchunk
# - flac

destination=./loom-pce

# Rip the CD to hard disk. The cdrdao command has a bewildering number
# of options, but apparently none for extracting single tracks. Oh
# well, most of the tracks are interesting in some way. These options
# worked for me. If all else fails, try a graphical front end.
#
# This step is time-consuming, so only do it if there isn't already an
# extracted loom.bin file there. It may be possible to generate a CUE
# file instead of a TOC file here, but I didn't manage to.

if [ ! -e loom.bin ] ; then
    cdrdao read-cd --read-raw --datafile loom.bin loom.toc
fi

# If there isn't a CUE file, convert the TOC file into something other
# programs can work with.

if [ ! -e loom.cue ] ; then
    toc2cue loom.toc loom.cue
fi

# Split the BIN/CUE files into individual tracks.

bchunk -w -s loom.bin loom.cue track

# Create an new directory for the final game

mkdir -p $destination

# Compress the audio tracks. Note that there is a gap in the numbering
# because of the data track.

flac -8 *.wav

mv track01.flac $destination

previous=02

for tracknr in `seq -w 3 22` ; do
    mv track$tracknr.flac $destination/track$previous.flac
    previous=$tracknr
done

# Finally, use scummvm-tools-cli to extract the oh-so-juicy data files.

scummvm-tools-cli --tool extract_loom_tg16 -o $destination track02.iso

# Cleanup

rm -f loom.toc track02.iso track23.iso track??.wav
